#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <stdlib.h>
#include <math.h>
#include <gtk/gtk.h>
#include <gdk/gdkkeysyms.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "main.h"

static guint gesture_timer = 0;
static gdouble gesture_start_x = 0.0;
static gdouble gesture_start_y = 0.0;

gboolean
gesture_timer_timeout(gpointer *data)
{
	printf("+++ GESTURE timeout \n");
	gesture_timer = 0;
	return FALSE; // removes timer	
}



void
on_button1_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
	go_back();
}


void
on_button2_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
	go_forward();
}


void
on_button3_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{

}


void
on_button4_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
	toggle_bookmark_view(0);
}


void
on_button5_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
	preferences_toggle_show(0);
}

void
on_button6_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
	fullscreen();
}

void
on_button7_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
	show_location_bar(TRUE);
}


void
on_button9_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
	static gboolean rotated = FALSE;
	
	if(rotated)
	{
		system("xrandr -o 0");
		rotated = FALSE;
	}
	else
	{
		system("xrandr -o 1");
		rotated = TRUE;
	}
}





void
on_button10_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
	go_to();
}



void
on_button11_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
	show_location_bar(FALSE);
}



void
on_button12_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
	add_bookmark();
}

void
on_entry1_changed                      (GtkEditable     *editable,
                                        gpointer         user_data)
{

}


gboolean
on_entry1_key_release_event            (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{
	printf("%s \n",__func__);
	if (event->keyval == GDK_Return || event->keyval == GDK_KP_Enter)
		go_to();
	else
		printf("keyval: %x \n", event->keyval);
  return FALSE;
}

gboolean
on_eventbox2_key_release_event         (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{
	printf("%s \n",__func__);

  return FALSE;
}

gboolean
on_eventbox2_button_release_event      (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
	printf("%s \n",__func__);
	fullscreen();
  return TRUE;
}



gboolean
on_eventbox3_button_release_event      (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
	fullscreen();
  return FALSE;
}
gboolean
on_eventbox4_button_release_event      (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
	go_back();
  return FALSE;
}


gboolean
on_eventbox5_button_release_event      (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
	go_forward();
  return FALSE;
}








gboolean
on_eventbox6_button_release_event      (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
	printf("%s \n",__func__);
	get_tree_iter();
	return TRUE; // stop further event propagation
}


gboolean
on_window1_configure_event             (GtkWidget       *widget,
                                        GdkEventConfigure *event,
                                        gpointer         user_data)
{
	win_resize();
  return FALSE;
}

gboolean
on_window1_key_release_event           (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{
	printf("%s \n",__func__);

	/* F11 fullscreen */
	if (event->keyval == GDK_F11)
		fullscreen();
	if ((event->state & GDK_CONTROL_MASK) == GDK_CONTROL_MASK)
	{
		/* Ctrl-L location bar */
		if (event->keyval == GDK_l || event->keyval == GDK_L)
			show_location_bar(TRUE);
		/* Ctrl-B bookmarks */
		else if (event->keyval == GDK_b || event->keyval == GDK_B)
			toggle_bookmark_view(0);
	}
	
	return FALSE;
}

gboolean
on_window1_button_press_event          (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{

  return TRUE;
}


gboolean
on_window1_button_release_event        (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
	//printf("%s x:%.0f y%.0f\n",__func__, event->x, event->y);
	static gdouble dx, dy;

	dx = event->x - gesture_start_x;
	dy = event->y - gesture_start_y;

	if(gesture_timer) 
	{
		
		g_source_remove(gesture_timer);
		gesture_timer = 0;
		

		
		printf("+++ GESTURE within 350ms, dx=%.0f dy=%.0f \n", dx, dy);
		if(dx < -80 && fabs(dy) < 60.0)
			go_back();
		else if (dx > 80 && fabs(dy) < 60)
			go_forward();
		else if (dy < -80 && fabs(dx) < 60)
			scroll_up();
		else if (dy > 20 && fabs(dx) < 60)
			scroll_down();
		/* tap in lower right corner */
		else if (fabs(dy) < 20 && 
			 fabs(dx) < 20 && 
			 event->x > (widget->allocation.width - 120) &&
			 event->y > (widget->allocation.height - 120))
		{
			scroll_down();
			printf("** %s: scroll_down - x:%.0f y%.0f \n", __func__, event->x, event->y);
		}
		/* tap in upper right corner */
		else if (fabs(dy) < 20 && 
			 fabs(dx) < 20 && 
			 event->x > (widget->allocation.width - 120) &&
			 event->y < 120)
			 scroll_up();
	}
	else
	{
		printf("+++ GESTURE button release without timer \n");
		
		if      (fabs(dy) < 20 && 
			 fabs(dx) < 20 && 
			 event->x > (widget->allocation.width - 120) &&
			 event->y > (widget->allocation.height - 120))
		{
			scroll_down();
			printf("** %s: scroll_down - x:%.0f y%.0f \n", __func__, event->x, event->y);
		}
		/* tap in upper right corner */
		else if (fabs(dy) < 20 && 
			 fabs(dx) < 20 && 
			 event->x > (widget->allocation.width - 120) &&
			 event->y < 120)
			 scroll_up();
	}
	

  return TRUE;
}




gboolean
on_window1_motion_notify_event         (GtkWidget       *widget,
                                        GdkEventMotion  *event,
                                        gpointer         user_data)
{
	//printf("%s x:%.0f y%.0f\n",__func__, event->x, event->y);
	/* remove timer */
	if(gesture_timer) 
		g_source_remove(gesture_timer);

	/* restart timer and set x,y */
	gesture_timer = g_timeout_add(650, (GSourceFunc)gesture_timer_timeout, NULL);
	gesture_start_x = event->x;
	gesture_start_y = event->y;
  return FALSE;
}

void
on_button13_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
	preferences_toggle_show(0);
}


void
on_checkbutton2_toggled                (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	gboolean active;
	
	active = gtk_toggle_button_get_active (togglebutton);
	prefs_image_load_toggle(active);
}


void
on_checkbutton1_toggled                (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	gboolean active;
	
	active = gtk_toggle_button_get_active (togglebutton);
	prefs_javascript_toggle(active);
}


void
on_entry2_changed                      (GtkEditable     *editable,
                                        gpointer         user_data)
{
	char *homepage = gtk_entry_get_text(GTK_ENTRY(editable));
	prefs_set_homepage(homepage);
}

void
on_spinbutton1_changed                 (GtkEditable     *editable,
                                        gpointer         user_data)
{
	int size;
	size = (int)gtk_spin_button_get_value(GTK_SPIN_BUTTON(editable));
	prefs_set_default_font_size(size);
}
